BaseAttack = class:extend("BaseAttack")

function BaseAttack:__init__(kwargs)
    self._kwargs = kwargs
    cwarn("No user in attack!",not kwargs.user and not kwargs)
    self.user = kwargs.user or kwargs or {}
    self.range = kwargs.range or 1
    self.exp = 0
    self.totalExp = 0
    self.level = 1
    self.totalLevel = kwargs.totalLevel or 12
    self.active = false
    
    self.strBonus = kwargs.strBonus or kwargs.strength or kwargs.strengthBonus or 3
end

function BaseAttack:peform(targ)
    self.user.attacking = true
    self.user.stats.strength = self.user.stats.strength + self.strBonus
    self.active = true
    if self.isEnemy then log(tostring(self).." attacked") end
    local target = targ or self.user.target
    
    target.stats.health = target.stats.health - self.user:getDamageTo(target)
    target.oldTile = target.tile
    self.user.stats.strength = self.user.stats.strength - self.strBonus
    self:gainExp(target)
    self:checkLevelUp()
    --This is a smAAASHH!!
    self:shake(target)
end


function BaseAttack:update(dt)
    if self.active then
        if not self.user.target.shaking then
            assert(self.user.attacking,tostring(self.user.attacking).." at "..tostring(self.user))
            if not self.user.stats.commander then
                assert(not self.user.done)
            else
                self.user.map:endturn()
                self.user.attacking = false
            end
            self.user.done = true
            --self.user.attacking = false
            self.active = false
            self:close()
            --error(self.user.stats.alias)
            -- love.timer.sleep(2)
        end
    end
end

function BaseAttack:draw()
end

function BaseAttack:gainExp(target)
    return 10
end

function BaseAttack:checkLevelUp()
end

function BaseAttack:levelUp()
    self.strBonus = self.strBonus+1
end

function BaseAttack:close()
    --Put any regrets that might
    --not have be accomplished here.
end

function BaseAttack:canUse(target)
    --check for limitations such as mana
    return true
end

function BaseAttack:shake(obj)
    getCamera():shakeObject(obj, 4, 1, 60)
end

return BaseAttack