local items = {
    Bread = Item:new({
        name = "bread",
        isEdible = true,
        isPerishable = true,
        isBurnable = true,
        life = 3,
        source = "bread.png",
        attack = 1, --can be used three times
        effect = {
            actor = "user",
            _if = {"get","self","isEaten","==",true},
            health = {
                "get",
                "user","health","+",
                5
            },
            --act = {"luaCode",...},
            --wait = time to wait before action
        },
        source = "bread.png"
    }),
    
    Leaf = Item:new({
        name = "leaf",
        source = "leaf.png",
        heal = 1,
        isEdible = true,
        isBurnable = true,
        life = 1,
        attack = 1,
        effect = {
            decode = {
                if_eaten = {
                    _if = {
                        "get",
                        {"get","self","isBurnt","==","false"},
                        "and",
                        {"get","self","isEaten","==",true},
                    },
                    actor = "user",
                    health = {
                        "get",
                        "user","health","+",
                        {"get","self","heal"}
                    }
                },
            }
        }
    })
}
                
return items
            
