_g = {}
for u,i in pairs(_G) do _g[u] = i end

function love.load()

    loadLuaCode = _G.load
    
    --class
    class = require 'tools/class'


    --home brewed helper functions
    require 'tools/tools'



    --home brewed helper classes
    Animation = require 'tools/animation'
    Scheduler = require 'tools/scheduler'
    Joystick = require 'tools/joystick'


    --stuffses
 --   cclass = require("tools/Goaplua/class")
   -- World = require("tools/GOAPlua/World")
 --   Planner = require("tools/GOAPluaPlanner")
  --  Action = require("tools/GOAPlua/Action")
    require 'tools/gooi'
   -- require "tools/goap"



    --helper functions/variables
    ProFi = require "tools/ProFi"
    color = require 'tools/color'
    mlib = require 'tools/mlib'
    sti = require "tools/sti"
    rot = require "tools/src.rot"
    lume = require 'tools/lume'
    colors = color
    bump = require 'tools/bump'
    inspect = require 'tools/inspect'



    --helper classes
    listbox = require 'tools/listbox'
    Paddy = require 'tools/paddy'
    JumperGrid = require "tools/jumper.grid"
    PathFinder = require "tools/jumper.pathfinder"
    Gamestate = require "tools/hump/gamestate"
    Signal = require "tools/hump/signal"
    Timer = require "tools/hump/timer"
    saveTable = require "tools/saveTable"
    splashy = require "tools/splashy"
    Graph = require "tools/graph"
    Andralog = require "tools/andralog"
    windfield = require "tools/windfield"
    wf = windfield

    --core stuff
    help = require "data/help"
    Game = require "game"
    Player = require "player"
    Camp = require "camp"
    Splash = require "splash"

    game = Game:new()
    player = Player:new()
    game:__init__()
    
    store = function(...) return game:store(...) end

    --ser= require "ser"
    --lo=load((ser(player)))()
    --error(lo.units)
    Biome = require 'noise/biomes'
    mapGen = require "noise/mapGen"



    --maps
    --TmxMap = require "maps/tmxmap"
    GridMap = require "maps/gridMap"
    DungeonFloor = require "maps/dungeons/dungeonFloor"
    Dungeon = require "maps/dungeons/dungeon"
    Underground = require "maps/underground"
    BattleScene = require "maps/battleScene"
    ZoomedCamp = require "maps/zoomedCamp"
    Overworld = require "maps/overworld"



    --menus
    infoMenu = require "menus/infoMenu"
    HelpMenu = require "menus/helpMenu"
    mainMenu = require "menus/mainMenu"
    PopUp = require "menus/popUp"
    GiverTaker = require "menus/giverTaker"
    UnitDisplay = require "menus/unitDisplay"



    --base classes
    Unit = require "bases/unit"
    Item = require "bases/item"
    BaseAttack = require "bases/baseAttack"



    --ai
    local AI = require "AI/ai"
    StatelessAI = require "AI/statelessAI"
    stateTransitionTable = require "AI/stateTransitionTable"
    stateMachine = require "AI/stateMachine"
    battleAI =StatelessAI.battleAI



    Camera = require 'tools/camera'







    Items = require "data/items"
    Attacks = require "data/attacks"
    Creatures = require "data/mobs"
    allCreatures = Creatures

    player:addItem(Items.edibles.Leaf)
    player:addItem(Items.edibles.Bread,3)
    player:addItem(Items.edibles.Bread)
    ---

    DT = 0
    DTmax = .5

    ---Shortcuts for often used functions, variables, etc...---
    Gs = Gamestate
    GS = Gamestate
    GSwitch = Gamestate.switch
    Gss = Gamestate.switch
    GSS = Gamestate.switch
    
    
    ---For switching back to the old state (can also use actual index in class: .oldState)---
    OLD_STATE = nil


    Gamestate.registerEvents()
    game:start()
    for i,o in pairs(love.audio) do log(i) end
    song = love.audio.newSource("b.mp3","static")
   -- for x,c in pairs(song) do log(x) end
    --song.loop=true
    love.audio.play(song)
   -- mainMenu:init()l
end
