

local floor = math.floor
AI = class:extend("AI")

function AI:__init__(units)
    self.units = units
    self.map = units[1].map
    self.ignore = {}

end

function AI:act()
cE=1
    if self.acted then
        log("\nacted already\n")
        return
    end
    self.ignore = {}
    self:actAgain()
end

function AI:actAgain()
    log("acting again...") assert(not self.elected)
    if self.selected and self.selected.path then
        return
    end
    self:getTargets()
    log("ACTED AGAIN!")
end

function AI:getTargets()
    local targets = {}
    local yunit = nil
    local wight = nil
    --log(#self.units) log(#self.map.units)
    done = nil
    for uu, unit in lume.iter(self.units) do
        local extra = {l=0,h=0}
        local weight, enemy
        unit.chosen = nil
        unit.check = nil
        if unit.enemy and not unit.enemy.stats.active then
            unit.enemy = nil
            unit.target = nil
            unit.weight = nil
        end
        if not unit.stats.active then
            unit.enemy = nil
            unit.target = nil
            unit.weight = nil
            log("skiiiippppppppppp")
           goto skip
        end
        unit.played = unit.played or 0
        for u,target in lume.iter(unit:getTargets()) do
        if not target.stats then log(target.stats) log(target.getX) end
            if not target.stats.active then
                goto continue
            end
            extra.h = 0 extra.l = 0
            if target.isEnemy or self.ignore[tostring(target)] then
                --This means the target is on AI's side
                goto continue --for now...(healers, etc)
            end
            
            local dis = lume.distance(target:getX(), target:getY(),unit:getX(),unit:getY())
            local att = unit:getDamage(target)--target.stats.health - unit:getDamage(target)
            local get = targets[tostring(unit)] or 0
    
            --something about enemies in attack range
            --fix values later
            
            local def =  target:getDamage(unit)--unit.stats.health - target:getDamage(unit)
            local inAttRange = unit:inAttackRange(target) and 1 or 0
            local willAtt = 0--unit:inAttackRange(target,) and 1 or 0
            if dis < 2 then
              --  extra.h = extra.h + 10000*(1/dis)
                log("too closeeee!!!")
            end
            extra.h = extra.h+1000*(1/dis)
            unit.canAttack = inAttRange

            for i,xx in lume.iter(getRound(2)) do
                local x = xx.x+target:getX()
                local y = xx.y+target:getY()
                enem = unit.map.grid[x] and unit.map.grid[x][y]
                if enem and enem.unit and not enem.unit.isEnemy then
                    extra.l = extra.l+enem.unit:getDamage(unit)
                elseif enem and enem.unit and enem.unit.isEnemy then
                    extra.h = extra.h+enem.unit:getDamage()
                end
            end
            
            local l =(dis+att+get+unit.played+extra.l)+1
            local h = (willAtt +inAttRange+def+1+unit.stats.movementRange+extra.h)+1
            local w = h/l
            assert(h>0 and l>0,"Bad calculation in ai")
            if unit.enemy then
                --floored so target won't keep changing
                if floor(w) <= floor(unit.weight) then
                    log(w.." not better than unit's "..unit.weight)
                    goto continue
                end
            end
            
            if not unit.weight or w > unit.weight then
                weight = w
                enemy = target
                unit.weight = w
                unit.totalWeight = w
                unit.enemy = enemy
            end
            ::continue::
        end
        ::skip::
        local ww=0
        if unit.enemy then
            local er = 0
            for i,xx in lume.iter(getRound(2)) do
                local x = xx.x+unit.enemy:getX()
                local y = xx.y+unit.enemy:getY()
                enem = unit.map.grid[x] and unit.map.grid[x][y]
                if enem and enem.unit and enem.unit.isEnemy then
                    er = er+enem.unit:getDamage(unit)
                end
            end
            unit.totalWeigth = er+ww
            log(tostring(unit).." has: "..unit.totalWeight.." and "..unit.weight)
            
            if not wight or unit.totalWeight > wight then
               yunit = unit
                wight = unit.totalWeight
            end
          --  unit.source = game:getSource("tmp.png")
        --    log("targeting")
            targets[tostring(unit.enemy)] = (targets[tostring(unit.enemy)] or 0) + 5
            unit.target = unit.enemy
          --[[-  unit.target.source = game:getSource("tmp.png")--[[
            if unit.canAttack == 1 then
                self:attackWith(unit)
            else
                self:moveUnit(unit)
            end]]--
    
        end
    end
  --  if not done then self.mafp.turn:toggle() end
    if yunit then
        log("yunit has: "..yunit.totalWeight.." and "..yunit.weight)
        yunit.chosen = 1
     --  -- log(yunit.weight.." wwww")
        yunit.played = yunit.played + 5
    if yunit:inAttackRange() then
        log("arrttack")
        yunit:attack()--.target.stats.life = 9--??
    yunit.map.turn:toggle()
    return
    end
        if yunit.canAttack == 1 then
           -- self:attackWith(yunit)
        else
            self:moveUnit(yunit)
            yunit.check = 1
        end
    end
end

function AI:moveUnit(unit)
    local p = unit:moveTo(unit.target.x, unit.target.y, true)
    if p then
        self.acted = true
      --  unit.map.turn:toggle()
   -- elseif p == false then
      --  self.map.turn:toggle()
    elseif not p then
    
        self.ignore[tostring(unit.target)] = unit.target
        unit.target = nil
        self:actAgain()
    end
end

function AI:attackWith(unit)
     log("att...")
    if unit:inAttackRange() then
        log("arrttack")
        unit:attack()--.target.stats.life = 9--??
    end
    unit.map.turn:toggle()
end


return AI