local BASE = (...) .. '.'
assert(not BASE:match('%.init%.$'), "Invalid require path `"..(...).."' (drop the `.init').")


function getNewCreature(creature)
    local creature = (type(creature) == "string" and Creatures[creature]) or creature
    
    if creature.new then
        return creature:new()
    else
        return forgeCreature(creature)
    end
end

function forgeCreature(creature)
    local _class = (creature.class and _G[creature.class]) or Unit
    return _class:new(creature)
end

return {
    Glop = require(BASE.."glop")
}