
mainMenu = {}

function mainMenu:init()
    b =Overworld:new({genRange={7,3},seed=nil,player=Camp:new()})--9,5



    b.usePaddy = false
    b.camera:setFollowStyle("None")
    b.camera.scale = 2.75
    self.b= b
    self.current = "menu"
    self.oldCurrent = nil
    
    self.menu = gooi.newPanel({
        w=W()/2, h=H()*.5,
        x=W()-((W()/2)/2)-W()/2,  y=0+(H()*.55)/2,
        group="menu",
        layout="grid 2x2"
    }):
    setColspan(1,1,2):
    add(
        gooi.newButton({text="Start",group="menu"}):
            onRelease(function(b)
               -- if b.text == "Start" then
               if ggr then error("You!") end
               log(lume.serialize(self.text))
                    self.current = "load"
                --end
            end
            ),
        gooi.newButton({text="Help",group="menu"}):
            onRelease(function()
                self.current = "help"
            end
            ),
        gooi.newButton({text="Exit",group="menu"}):
            onRelease(function()
                game:quit()
            end
            )
        
    )
        
    self.load = gooi.newPanel({
        w=W()/2, h=H()*.45,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="load",
        layout="grid 2x2"
    }):
    setColspan(1,1,2):
    add(
        gooi.newButton({text="Resume",group="load"}):
            onRelease(function(b)
                if game:hasSavedGame() then
                    game:loadGame()
                end
            end
            ),
        gooi.newButton({text="New",group="load"}):
            onRelease(function()
                self.current = "new"
            end
            ),
        gooi.newButton({text="Back",group="load"}):
            onRelease(function()
                self.current = "menu"
            end
            )
        )
    
    self.wName = gooi.newText({group="new"})
    self.wSeed = gooi.newText({group="new"})
    
    self.new = gooi.newPanel({
        w=W()/2, h=H()*.65,
        x=W()-((W()/2)/2)-W()/2, y=0+(H()*.55)/2,
        group="new",
        layout="grid 11x1"
    }):
    add(
        gooi.newButton({text="CREATE",group="new"}):
            onRelease(function()
                game:startNewGame()
            end),
        gooi.newLabel({text="Difficulty",group="new"}):left(),
        gooi.newRadio({text="easy",radioGrop="d",group="new"}),
        gooi.newRadio({text="medium",radioGrop="d",group="new"}),
        gooi.newRadio({text="hard",radioGrop="d",group="new"}),
        gooi.newRadio({text="expert",radioGrop="d",group="new"}),
        gooi.newLabel({text="World name",group="new"}):left(),
        self.wName,
        gooi.newLabel({text="World seed",group="new"}):left(),
        self.wSeed,
        gooi.newButton({text="Back",group="load"}):
            onRelease(function()
                self.current = "load"
            end
            )
        
    )
    
    self.help = HelpMenu:new({group="help"})
    self._current = self.menu
        
    self.menus = {
        load = self.load,
        menu = self.menu,
        new = self.new,
        help = self.help
    }
end

function mainMenu:update(dt)
    local trash = self._current.update and self._current:update(dt) or gooi.update(dt)
    
    if self.oldCurrent ~= self.current then
    if self.current=="new" then ggr=4 end
        for i,n in lume.iter(self.menus) do
            local trash = n.destroy and n:destroy()
            gooi.removeComponent(n)--self.menus[self.current])
        end
        gooi.pressed() gooi.released()
        local m = self.menus[self.current]
        local trash = m.create and m:create()
        gooi.addComponent(m.__class and m.info or m)
        self.oldCurrent = self.current
    end
    self._current = self.menus[self.current]
    local speed=self.b.tile.w
    --self.b.player._x = self.b.player.x + speed
    --self.b.offset._x = self.b.offset._x + speed
    
    self.b:update(dt,nil,true)
       
end

function mainMenu:enter()
    self:init()
end

function mainMenu:resume()
    self:init()
end


function mainMenu:draw()
    self.b:draw()
    local trash = self._current.draw and self._current:draw() or
        gooi.draw(self.current)
--    gooi.draw()
end

function mainMenu:leave()
    for i,n in lume.iter(self.menus) do
        local trash = n.destroy and n:destroy()
        gooi.removeComponent(n)--self.menus[self.current])
    end
    self.b:destroy()
end

function mainMenu:mousereleased() gooi.released() log("released") end
function mainMenu:mousepressed()  gooi.pressed() log("pressed") end

function mainMenu:touchreleased(id, x, y, dx, dy, pressure)
    if not self.buttonPressed then
        ttx = x
        tty = y
    end
    self.buttonPressed = false
    local trash = self._current.touchreleased and 
        self._current:touchreleased(id,x,y,dx,dy,pressure)
end

function mainMenu:touchpressed(id, x, y, dx, dy, pressure)

    local trash = self._current.touchpressed and 
        self._current:touchpressed(id,x,y,dx,dy,pressure)
    end
function mainMenu:textinput(text)
  gooi.textinput(text)
end

function mainMenu:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function mainMenu:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end

return mainMenu