local mapGen = {
    heights = {
        {
            name = "DeepWater",
            value = 0.2--3
        },
        {
            name = "ShallowWater",
            value = 0.3--4
        },
        {
            name = "Sand",
            value = 0.5,
        },
        {
            name = "Grass",
            value = 0.7,
        },
        {
            name = "Forest",
            value = 0.8,
        },
        {
            name = "Rock",
            value = 0.9
        },
        {
            name = "Snow",
            value = 1
        },
        frequency = 2,--.25,
        octaves = 4--,
        
        
    },
    temperatures = {
        {
            name = "Coldest",
            value = 0.05,
        },
        {
            name = "Colder",
            value = 0.18,
        },
        {
            name = "Cold",
            value = 0.4
        },
        {
            name = "Warm",
            value = 0.6
        },
        {
            name = "Warmer",
            value = 0.8
        },
        {
            name = "Warmest",
            value = 1
        },
        frequency = 3,
        octaves = 4
            
    },
    moisture = {
        {
            name = "Dryest",
            value = 0.17
        },
        {
            name = "Dryer",
            value = 0.24
        },
        {
            name = "Dry",
            value = 0.46
        },
        {
            name = "Wet",
            value = 0.8
        },
        {
            name = "Wetter",
            value = 0.8
        },
        {
            name = "Wettest",
            value = 1--0.9
        },
        frequency = 3,
        octaves = 4
        
        
    },
    river = {
        frequency = 1,
        octaves = 2
    },
    tree = {
        frequency = 60,
        octaves = 1--?
    }
}

return mapGen