Scheduler = class:extend("Scheduler")

function Scheduler:__init__()
    self._schedules = {}
    self._sch = {}
end

function Scheduler:schedule(check,doo)
    table.insert(self._schedules,{check,doo})
    self._sch = lume.copy(self._schedules)
end

function Scheduler:update(dt)
    local remove = nil
    for _,x in ipairs(self._sch) do
        if x[1]() then
            table.remove(self._schedules,_)
            remove = 1
            x[2]()
        end
    end
    if remove then
        self._sch = lume.copy(self._schedules)
    end
end

return Scheduler